#include "spnLight.hpp"
#define PL_SIG_SREC_LP 0
#define PL_Heater_LP 1
#define PL_Parameter_Serial_LP 2
#define TR_EMPTY_SREC_RT 0
#define TR_INCOMING_SREC_RT 1
#define TR_I1062_S_HOFF_L_DataReceived_RT 2
#define TR_I1061_S_HON_L_DataReceived_RT 3
#define TR_I1060_S_HON_L_Off_L_DataReceived_RT 4
#define TR_I1059_S_HOFF_L_On_L_DataReceived_RT 5
#define TR_I1046_L_DataReceived_RT 6
#define TR_RSREC1019__RT 7
#define TR_I1065_L_Init_RT 8
#define TR_I1045_L_DataReceived1_RT 9
#define TR_I1044_L_DataReceived1_RT 10
#define TR_I1042_L_DataReceived_RT 11
#define TR_D1008_L_Off_RT 12
#define TR_D1013_L_On_RT 13

const int _nb_Place_SIG_SREC=0;
const int _nb_Place_Heater=1;
const int _nb_Place_Parameter_Serial=2;
namespace hybridVar {
}
#include "magic.hpp"
#include "markingImpl.hpp"

void abstractMarking::resetToInitMarking(){
	magicReset();
	P->_PL_SIG_SREC =0;
	P->_PL_Heater =998;
	P->_PL_Parameter_Serial =1024;
}


abstractMarking::abstractMarking() {
	P= new abstractMarkingImpl;
	resetToInitMarking();
}

abstractMarking::~abstractMarking() {
	delete(P);
}


void abstractMarking::printHeader()const{
::print("SIG_SREC	");
::print("Heater	");
::print("Parameter_Serial	");
}

void abstractMarking::print()const{
print_magic(P->_PL_SIG_SREC);
::print("	");
print_magic(P->_PL_Heater);
::print("	");
print_magic(P->_PL_Parameter_Serial);
::print("	");
}
static const TR_PL_ID EMPTY_array[1]={-1};
static const TR_PL_ID PE_PossiblyEnabled_0[2]= {TR_INCOMING_SREC_RT, -1 }; /* EMPTY_SREC*/
static const TR_PL_ID PE_PossiblyEnabled_1[3]= {TR_EMPTY_SREC_RT, TR_RSREC1019__RT, -1 }; /* INCOMING_SREC*/
static const TR_PL_ID PE_PossiblyEnabled_2[3]= {TR_RSREC1019__RT, TR_D1008_L_Off_RT, -1 }; /* I1062_S_HOFF_L_DataReceived*/
static const TR_PL_ID PE_PossiblyEnabled_3[3]= {TR_RSREC1019__RT, TR_D1013_L_On_RT, -1 }; /* I1061_S_HON_L_DataReceived*/
static const TR_PL_ID PE_PossiblyEnabled_4[3]= {TR_RSREC1019__RT, TR_D1013_L_On_RT, -1 }; /* I1060_S_HON_L_Off_L_DataReceived*/
static const TR_PL_ID PE_PossiblyEnabled_5[3]= {TR_RSREC1019__RT, TR_D1008_L_Off_RT, -1 }; /* I1059_S_HOFF_L_On_L_DataReceived*/
static const TR_PL_ID PE_PossiblyEnabled_6[2]= {TR_RSREC1019__RT, -1 }; /* I1046_L_DataReceived*/
static const TR_PL_ID PE_PossiblyEnabled_7[4]= {TR_EMPTY_SREC_RT, TR_INCOMING_SREC_RT, TR_I1065_L_Init_RT, -1 }; /* RSREC1019_*/
static const TR_PL_ID PE_PossiblyEnabled_8[7]= {TR_I1062_S_HOFF_L_DataReceived_RT, TR_I1061_S_HON_L_DataReceived_RT, TR_I1060_S_HON_L_Off_L_DataReceived_RT, TR_I1059_S_HOFF_L_On_L_DataReceived_RT, TR_I1046_L_DataReceived_RT, TR_I1042_L_DataReceived_RT, -1 }; /* I1065_L_Init*/
static const TR_PL_ID PE_PossiblyEnabled_9[2]= {TR_RSREC1019__RT, -1 }; /* I1045_L_DataReceived1*/
static const TR_PL_ID PE_PossiblyEnabled_10[2]= {TR_RSREC1019__RT, -1 }; /* I1044_L_DataReceived1*/
static const TR_PL_ID PE_PossiblyEnabled_11[3]= {TR_I1045_L_DataReceived1_RT, TR_I1044_L_DataReceived1_RT, -1 }; /* I1042_L_DataReceived*/
static const TR_PL_ID PE_PossiblyEnabled_12[3]= {TR_I1062_S_HOFF_L_DataReceived_RT, TR_I1060_S_HON_L_Off_L_DataReceived_RT, -1 }; /* D1008_L_Off*/
static const TR_PL_ID PE_PossiblyEnabled_13[3]= {TR_I1061_S_HON_L_DataReceived_RT, TR_I1059_S_HOFF_L_On_L_DataReceived_RT, -1 }; /* D1013_L_On*/
const TR_PL_ID* SPN::PossiblyEnabled[] = {PE_PossiblyEnabled_0, PE_PossiblyEnabled_1, PE_PossiblyEnabled_2, PE_PossiblyEnabled_3, PE_PossiblyEnabled_4, PE_PossiblyEnabled_5, PE_PossiblyEnabled_6, PE_PossiblyEnabled_7, PE_PossiblyEnabled_8, PE_PossiblyEnabled_9, PE_PossiblyEnabled_10, PE_PossiblyEnabled_11, PE_PossiblyEnabled_12, PE_PossiblyEnabled_13};

static const TR_PL_ID PE_PossiblyDisabled_0[2]= {TR_RSREC1019__RT, -1 }; /* EMPTY_SREC*/
static const TR_PL_ID PE_PossiblyDisabled_2[5]= {TR_I1060_S_HON_L_Off_L_DataReceived_RT, TR_I1046_L_DataReceived_RT, TR_I1042_L_DataReceived_RT, TR_D1008_L_Off_RT, -1 }; /* I1062_S_HOFF_L_DataReceived*/
static const TR_PL_ID PE_PossiblyDisabled_3[5]= {TR_I1059_S_HOFF_L_On_L_DataReceived_RT, TR_I1046_L_DataReceived_RT, TR_I1042_L_DataReceived_RT, TR_D1013_L_On_RT, -1 }; /* I1061_S_HON_L_DataReceived*/
static const TR_PL_ID PE_PossiblyDisabled_4[5]= {TR_I1062_S_HOFF_L_DataReceived_RT, TR_I1046_L_DataReceived_RT, TR_I1042_L_DataReceived_RT, TR_D1008_L_Off_RT, -1 }; /* I1060_S_HON_L_Off_L_DataReceived*/
static const TR_PL_ID PE_PossiblyDisabled_5[5]= {TR_I1061_S_HON_L_DataReceived_RT, TR_I1046_L_DataReceived_RT, TR_I1042_L_DataReceived_RT, TR_D1013_L_On_RT, -1 }; /* I1059_S_HOFF_L_On_L_DataReceived*/
static const TR_PL_ID PE_PossiblyDisabled_6[6]= {TR_I1062_S_HOFF_L_DataReceived_RT, TR_I1061_S_HON_L_DataReceived_RT, TR_I1060_S_HON_L_Off_L_DataReceived_RT, TR_I1059_S_HOFF_L_On_L_DataReceived_RT, TR_I1042_L_DataReceived_RT, -1 }; /* I1046_L_DataReceived*/
static const TR_PL_ID PE_PossiblyDisabled_7[3]= {TR_EMPTY_SREC_RT, TR_INCOMING_SREC_RT, -1 }; /* RSREC1019_*/
static const TR_PL_ID PE_PossiblyDisabled_9[2]= {TR_I1044_L_DataReceived1_RT, -1 }; /* I1045_L_DataReceived1*/
static const TR_PL_ID PE_PossiblyDisabled_10[2]= {TR_I1045_L_DataReceived1_RT, -1 }; /* I1044_L_DataReceived1*/
static const TR_PL_ID PE_PossiblyDisabled_11[6]= {TR_I1062_S_HOFF_L_DataReceived_RT, TR_I1061_S_HON_L_DataReceived_RT, TR_I1060_S_HON_L_Off_L_DataReceived_RT, TR_I1059_S_HOFF_L_On_L_DataReceived_RT, TR_I1046_L_DataReceived_RT, -1 }; /* I1042_L_DataReceived*/
static const TR_PL_ID PE_PossiblyDisabled_12[3]= {TR_I1062_S_HOFF_L_DataReceived_RT, TR_I1060_S_HON_L_Off_L_DataReceived_RT, -1 }; /* D1008_L_Off*/
static const TR_PL_ID PE_PossiblyDisabled_13[3]= {TR_I1061_S_HON_L_DataReceived_RT, TR_I1059_S_HOFF_L_On_L_DataReceived_RT, -1 }; /* D1013_L_On*/
const TR_PL_ID* SPN::PossiblyDisabled[] = {PE_PossiblyDisabled_0, EMPTY_array, PE_PossiblyDisabled_2, PE_PossiblyDisabled_3, PE_PossiblyDisabled_4, PE_PossiblyDisabled_5, PE_PossiblyDisabled_6, PE_PossiblyDisabled_7, EMPTY_array, PE_PossiblyDisabled_9, PE_PossiblyDisabled_10, PE_PossiblyDisabled_11, PE_PossiblyDisabled_12, PE_PossiblyDisabled_13};

const TR_PL_ID* SPN::FreeMarkDepT[] = {EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array};

SPN::SPN():
pl(3), tr(14) {
}

TR_PL_ID SPN::getIncomingTrans(){ return TR_INCOMING_SREC_RT;};

bool SPN::IsEnabled(TR_PL_ID t)const{
	if(!magicConditional(t))return false;

	switch (t){
		case 7:	//RSREC1019_

			if (!(contains(Marking.P->_PL_SIG_SREC , 1))) return false;
			if( Marking.P->_PL_Parameter_Serial != 1024) return false;
		return true;
		break;
		case 0:	//EMPTY_SREC

			if (!(contains(Marking.P->_PL_SIG_SREC , 1))) return false;
		return true;
		break;
		case 12:	//D1008_L_Off

			if( Marking.P->_PL_Heater != 998) return false;
		return true;
		break;
		case 3:	//I1061_S_HON_L_DataReceived
		case 5:	//I1059_S_HOFF_L_On_L_DataReceived

			if( Marking.P->_PL_Heater != 999) return false;
			if( Marking.P->_PL_Parameter_Serial != 1017) return false;
		return true;
		break;
		case 13:	//D1013_L_On

			if( Marking.P->_PL_Heater != 999) return false;
		return true;
		break;
		case 6:	//I1046_L_DataReceived
		case 11:	//I1042_L_DataReceived

			if( Marking.P->_PL_Parameter_Serial != 1017) return false;
		return true;
		break;
		case 9:	//I1045_L_DataReceived1
		case 10:	//I1044_L_DataReceived1

			if( Marking.P->_PL_Parameter_Serial != 1043) return false;
		return true;
		break;
		case 8:	//I1065_L_Init

			if( Marking.P->_PL_Parameter_Serial != 1064) return false;
		return true;
		break;
		case 1:	//INCOMING_SREC

    if (Marking.P->_PL_SIG_SREC >= 0) return false;
		return true;
		break;
		default:	//I1062_S_HOFF_L_DataReceived,I1060_S_HON_L_Off_L_DataReceived,

			if( Marking.P->_PL_Heater != 998) return false;
			if( Marking.P->_PL_Parameter_Serial != 1017) return false;
		return true;
		break;
	}
}

void SPN::fire(TR_PL_ID t,REAL_TYPE time){
	lastTransition = t;
	magicUpdate(t,time);

	switch (t){
		case 2:	//I1062_S_HOFF_L_DataReceived
{
			Marking.P->_PL_Heater -= 998;
			Marking.P->_PL_Heater += 998;
			Marking.P->_PL_Parameter_Serial -= 1017;
			Marking.P->_PL_Parameter_Serial += 1024;
	}
		break;
		case 12:	//D1008_L_Off
{
			Marking.P->_PL_Heater -= 998;
			Marking.P->_PL_Heater += 998;
	}
		break;
		case 4:	//I1060_S_HON_L_Off_L_DataReceived
{
			Marking.P->_PL_Heater -= 998;
			Marking.P->_PL_Heater += 999;
			Marking.P->_PL_Parameter_Serial -= 1017;
			Marking.P->_PL_Parameter_Serial += 1024;
	}
		break;
		case 5:	//I1059_S_HOFF_L_On_L_DataReceived
{
			Marking.P->_PL_Heater -= 999;
			Marking.P->_PL_Heater += 998;
			Marking.P->_PL_Parameter_Serial -= 1017;
			Marking.P->_PL_Parameter_Serial += 1024;
	}
		break;
		case 3:	//I1061_S_HON_L_DataReceived
{
			Marking.P->_PL_Heater -= 999;
			Marking.P->_PL_Heater += 999;
			Marking.P->_PL_Parameter_Serial -= 1017;
			Marking.P->_PL_Parameter_Serial += 1024;
	}
		break;
		case 13:	//D1013_L_On
{
			Marking.P->_PL_Heater -= 999;
			Marking.P->_PL_Heater += 999;
	}
		break;
		case 6:	//I1046_L_DataReceived
{
			Marking.P->_PL_Parameter_Serial -= 1017;
			Marking.P->_PL_Parameter_Serial += 1024;
	}
		break;
		case 11:	//I1042_L_DataReceived
{
			Marking.P->_PL_Parameter_Serial -= 1017;
			Marking.P->_PL_Parameter_Serial += 1043;
	}
		break;
		case 8:	//I1065_L_Init
{
			Marking.P->_PL_Parameter_Serial -= 1064;
			Marking.P->_PL_Parameter_Serial += 1017;
	}
		break;
		case 1:	//INCOMING_SREC
{
			Marking.P->_PL_SIG_SREC += 1;
	}
		break;
		case 7:	//RSREC1019_
{
			Marking.P->_PL_SIG_SREC -= 1;
			Marking.P->_PL_SIG_SREC += 1;
			Marking.P->_PL_Parameter_Serial -= 1024;
			Marking.P->_PL_Parameter_Serial += 1064;
	}
		break;
		case 0:	//EMPTY_SREC
{
			Marking.P->_PL_SIG_SREC -= 1;
	}
		break;
		default:	//I1045_L_DataReceived1,I1044_L_DataReceived1,
{
			Marking.P->_PL_Parameter_Serial -= 1043;
			Marking.P->_PL_Parameter_Serial += 1024;
	}
		break;
	}
}

void SPN::setConditionsVector(){
}
void SPN::GetDistParameters(TR_PL_ID t)const{
using namespace hybridVar;

	switch (t){
		case 12:	//D1008_L_Off
		case 13:	//D1013_L_On
	{
		ParamDistr[0]= ( double ) T_INC ;
	}

		break;
		default:	//EMPTY_SREC,INCOMING_SREC,I1062_S_HOFF_L_DataReceived,I1061_S_HON_L_DataReceived,I1060_S_HON_L_Off_L_DataReceived,I1059_S_HOFF_L_On_L_DataReceived,I1046_L_DataReceived,RSREC1019_,I1065_L_Init,I1045_L_DataReceived1,I1044_L_DataReceived1,I1042_L_DataReceived,
	{
		ParamDistr[0]= ( double ) 0 ;
	}

		break;
	}
}

REAL_TYPE SPN::GetPriority(TR_PL_ID t)const{
using namespace hybridVar;

	switch (t){
		case 12:	//D1008_L_Off
		case 13:	//D1013_L_On
		return (double)0.99 ;
		break;
		case 0:	//EMPTY_SREC
		return (double)3 ;
		break;
		case 7:	//RSREC1019_
		return (double)3.99 ;
		break;
		case 1:	//INCOMING_SREC
		return (double)5 ;
		break;
		default:	//I1062_S_HOFF_L_DataReceived,I1061_S_HON_L_DataReceived,I1060_S_HON_L_Off_L_DataReceived,I1059_S_HOFF_L_On_L_DataReceived,I1046_L_DataReceived,I1065_L_Init,I1045_L_DataReceived1,I1044_L_DataReceived1,I1042_L_DataReceived,
		return (double)1.98 ;
		break;
	}
}

REAL_TYPE SPN::GetWeight(TR_PL_ID t)const{
using namespace hybridVar;

		return (double)1 ;
}

void SPN::reset() {
	lastTransitionTime = 0;
	Marking.resetToInitMarking();
}

